#include "EsoCommon_Header.hpp"
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++

void a1_acs_sum(int bmode_1, double* x, double* a1_x, int& len, double& sum_x, double& a1_sum_x)
#pragma ad indep x a1_x a1_sum_x
#pragma ad dep sum_x a1_x
{
   int i=0; 
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0; 
   double v1_2=0; 
   double a1_v1_2=0;
   int save_cs_c=0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      for ( i=0; i<len; i=i+1) {
         cs[cs_c]=0; cs_c=cs_c+1;
         fds[fds_c]=sum_x; fds_c=fds_c+1; sum_x=sum_x+x[i];
         ids[ids_c]=i; ids_c=ids_c+1;       }
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          // incomplete SAC
          ids_c=ids_c-1; i=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; sum_x=fds[fds_c];
          v1_0=sum_x;
          v1_1=x[i];
          v1_2=v1_0+v1_1;
          // adjoint assignment
          a1_v1_2=a1_sum_x; a1_sum_x=0;
          a1_v1_0=a1_v1_2; a1_v1_1=a1_v1_2;
          a1_x[i]=a1_x[i]+a1_v1_1;
          a1_sum_x=a1_sum_x+a1_v1_0;
        }
      }
   }
   if (bmode_1==2) {
      acs_sum(x, len, sum_x);
   }
}
void a1_acs_pow(int bmode_1, double& a, double& a1_a, double& x, double& a1_x, double& v_pow, double& a1_v_pow)
#pragma ad indep a a1_a x a1_x a1_v_pow
#pragma ad dep v_pow a1_a a1_x
{
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0;
   double res_pow=0;
   int save_cs_c=0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      cs[cs_c]=0; cs_c=cs_c+1;
      fds[fds_c]=v_pow; fds_c=fds_c+1; acs_pow(a,x,v_pow);
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          fds_c=fds_c-1; v_pow=fds[fds_c]; 
          v1_0=a;
          acs_pow(v1_0,x,v1_1);
          a1_v1_1=a1_v_pow; a1_v_pow=0;
          a1_v1_0=x-1;
          acs_pow(v1_0,a1_v1_0,res_pow);
          a1_v1_0=x*res_pow*a1_v1_1;
          a1_x=a1_x+v1_1*dcc_log(v1_0)*a1_v1_1;
          a1_a=a1_a+a1_v1_0;

        }
      }
   }
   if (bmode_1==2) {
      acs_pow(a, x, v_pow);
   }
}
void a1_acs_div(int bmode_1, double& top_arg, double& a1_top_arg, double& bottom_arg, double& a1_bottom_arg, double& v_div, double& a1_v_div)
#pragma ad indep top_arg a1_top_arg bottom_arg a1_bottom_arg a1_v_div
#pragma ad dep v_div a1_top_arg a1_bottom_arg
{
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0; 
   double v1_2=0; 
   double a1_v1_2=0;
   double div_ret1=0;
   double div_ret2=0;
   double int_ret1=0;
   double one=0;
   int save_cs_c=0;
   one=1.0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      cs[cs_c]=0; cs_c=cs_c+1;
      fds[fds_c]=v_div; fds_c=fds_c+1; acs_div(top_arg, bottom_arg, v_div);
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          fds_c=fds_c-1; v_div=fds[fds_c]; 
          v1_0=top_arg;
          v1_1=bottom_arg;
          acs_div(v1_0, v1_1, v1_2);
          a1_v1_2=a1_v_div; a1_v_div=0;
          acs_div(one, v1_1, div_ret1);
          a1_v1_0=div_ret1*a1_v1_2; int_ret1=v1_1*v1_1; 
          acs_div(v1_0, int_ret1, div_ret2); a1_v1_1=0-div_ret2*a1_v1_2;
          a1_bottom_arg=a1_bottom_arg+a1_v1_1;
          a1_top_arg=a1_top_arg+a1_v1_0;
        }
      }
   }
   if (bmode_1==2) {
      acs_div(top_arg, bottom_arg, v_div);
   }
}
void a1_acs_sqrt(int bmode_1, double& arg, double& a1_arg, double& v_sqrt, double& a1_v_sqrt)
#pragma ad indep arg a1_arg a1_v_sqrt
#pragma ad dep v_sqrt a1_arg
{
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0;
   double div_ret1=0;
   double sqrt_ret1=0;
   double int_ret1=0;
   double one=0;
   int save_cs_c=0;
   one=1.0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      cs[cs_c]=0; cs_c=cs_c+1;
      fds[fds_c]=v_sqrt; fds_c=fds_c+1; acs_sqrt(arg, v_sqrt);
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          fds_c=fds_c-1; v_sqrt=fds[fds_c]; 
          v1_0=arg;
          acs_sqrt(v1_0, v1_1);
          a1_v1_1=a1_v_sqrt; a1_v_sqrt=0;
          acs_sqrt(v1_0, sqrt_ret1);
          int_ret1=2*sqrt_ret1;
          acs_div(one, int_ret1, div_ret1);
          a1_v1_0=div_ret1*a1_v1_1;
          a1_arg=a1_arg+a1_v1_0;
        }
      }
   }
   if (bmode_1==2) {
      acs_sqrt(arg, v_sqrt);
   }
}
void a1_acs_ln(int bmode_1, double& arg, double& a1_arg, double& v_ln, double& a1_v_ln)
#pragma ad indep arg a1_arg a1_v_ln
#pragma ad dep v_ln a1_arg
{
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0;
   int save_cs_c=0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      cs[cs_c]=0; cs_c=cs_c+1;
      fds[fds_c]=v_ln; fds_c=fds_c+1; acs_ln(arg, v_ln);
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          fds_c=fds_c-1; v_ln=fds[fds_c]; 
          v1_0=arg;
          acs_ln(v1_0, v1_1);
          a1_v1_1=a1_v_ln; a1_v_ln=0;
          acs_div(a1_v1_1, v1_0, a1_v1_0);
          a1_arg=a1_arg+a1_v1_0;
        }
      }
   }
   if (bmode_1==2) {
      acs_ln(arg, v_ln);
   }
}
void a1_acs_exp(int bmode_1, double& arg, double& a1_arg, double& v_exp, double& a1_v_exp)
#pragma ad indep arg a1_arg a1_v_exp
#pragma ad dep v_exp a1_arg
{
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0;
   int save_cs_c=0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      cs[cs_c]=0; cs_c=cs_c+1;
      fds[fds_c]=v_exp; fds_c=fds_c+1; acs_exp(arg, v_exp);
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          fds_c=fds_c-1; v_exp=fds[fds_c]; 
          v1_0=arg;
          acs_exp(v1_0, v1_1);
          a1_v1_1=a1_v_exp; a1_v_exp=0;
          a1_v1_0=v1_1*a1_v1_1;
          a1_arg=a1_arg+a1_v1_0;
        }
      }
   }
   if (bmode_1==2) {
      acs_exp(arg, v_exp);
   }
}
void a1_acs_tanh(int bmode_1, double& arg, double& a1_arg, double& v_tanh, double& a1_v_tanh)
#pragma ad indep arg a1_arg a1_v_tanh
#pragma ad dep v_tanh a1_arg
{
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0;
   int save_cs_c=0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      cs[cs_c]=0; cs_c=cs_c+1;
      fds[fds_c]=v_tanh; fds_c=fds_c+1; acs_tanh(arg, v_tanh);
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          fds_c=fds_c-1; v_tanh=fds[fds_c]; 
          v1_0=arg;
          acs_tanh(v1_0, v1_1);
          a1_v1_1=a1_v_tanh; a1_v_tanh=0;
          a1_v1_0=(1-v1_1*v1_1)*a1_v1_1;
          a1_arg=a1_arg+a1_v1_0;
        }
      }
   }
   if (bmode_1==2) {
      acs_tanh(arg, v_tanh);
   }
}
